#
# u2d1.rb
#   $Id: u2d1.rb,v 1.1 2000/11/18 18:57:45 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math

NT = 51
NZ = 21
TMIN = 0.0
TMAX = 5.0
ZMIN = 20.0
ZMAX = 50.0
DT = (TMAX-TMIN)/(NT-1)
DZ = (ZMAX-ZMIN)/(NZ-1)

u = NArray.sfloat(NT, NZ)

#-- data ----
for j in 0..NZ-1
  zj = j*DZ
  uz = exp(-0.2*zj)*(zj**0.5)
  for i in 0..NT-1
    ti = i*DT-2.0*exp(-0.1*zj)
    u[i,j] = uz*sin(3.0*ti)
  end
end

#-- graph ----
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws
grfrm

grswnd(TMIN, TMAX, ZMIN, ZMAX)
uspfit
grstrf

ussttl('TIME', 'YEAR', 'HEIGHT', 'km')
usdaxs

udcntr(u)

grcls

