#
# map3d5.rb
#   $Id: map3d5.rb,v 1.1 2000/11/18 19:03:40 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math


NX = 21
NY = 21
XMIN = -10
XMAX = 10
YMIN = -10
YMAX = 10
VXMIN = 0.2
VXMAX = 0.8
VYMIN = 0.1
VYMAX = 0.5
ZMIN = 0.0
ZMAX = 20
VZMIN = 0.0
VZMAX = 0.6
XVP3 = -0.7
YVP3 = -0.7
ZVP3 = 1.2
XFC3 = (VXMAX-VXMIN)/2
YFC3 = (VYMAX-VYMIN)/2
ZFC3 = (VZMAX-VZMIN)/2
DX1 = 1
DX2 = 5
DY1 = 1
DY2 = 4
DZ1 = 1
DZ2 = 5
KMAX = 5
PMIN = 0
PMAX = 1
u = NArray.sfloat(NX, NY)
v = NArray.sfloat(NX, NY)
p = NArray.sfloat(NX, NY)

#-- data ---
for j in 0..NY-1
  for i in 0..NX-1
    x = XMIN + (XMAX-XMIN)*i/(NX-1).to_f
    y = YMIN + (YMAX-YMIN)*j/(NY-1).to_f
    u[i,j] =  x
    v[i,j] = -y
    p[i,j] = exp(-x**2/64 -y**2/25)
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
sgopn iws

sgfrm

#-- X-Y ʿ: ٥ ----
sgswnd(XMIN, XMAX, YMIN, YMAX)
sgsvpt(VXMIN, VXMAX, VYMIN, VYMAX)
sgstrn(1)
sgstrf

scspln(1, 2, VZMIN)
scseye(XVP3, YVP3, ZVP3)
scsobj(XFC3, YFC3, ZFC3)
scsprj

uxaxdv('B', DX1, DX2)
uxaxdv('T', DX1, DX2)
uxsttl('B', 'X-axis', 0.0)

uyaxdv('L', DY1, DY2)
uyaxdv('R', DY1, DY2)
uysttl('L', 'Y-axis', 0.0)

ugrset('RSIZET', 0.014)
ugvect(u, v)

#-- X-Y ʿ: ٥ ----
vzlev = VZMIN + (VZMAX-VZMIN)*0.6
scspln(1, 2, vzlev)
scsprj

dp = (PMAX-PMIN)/KMAX.to_f
for k in 1..KMAX
  tlev1 = (k-1)*dp
  tlev2 = tlev1 + dp
  ipat  = 600 + k - 1
  uestlv(tlev1, tlev2, ipat)
end
uetone(p)

udlset('LMSG', false)
udgclb(p, 0.1)
udcntr(p)
slpvpr(1)

#-- X-Z ʿ ----
sgswnd(XMIN, XMAX, ZMIN, ZMAX)
sgsvpt(VXMIN, VXMAX, VZMIN, VZMAX)
sgstrn(1)
sgstrf

scspln(1, 3, VYMAX)
scsprj

uzinit
uyaxdv('L', DZ1, DZ2)
uysttl('L', 'Z-axis', 0.0)

sgcls

