#
# miss2.rb
#   $Id: miss2.rb,v 1.1 2000/11/18 19:03:40 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math


NX = 37
NY = 37
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = 90
DRAD = PI/180
p = NArray.sfloat(NX, NY)

rmiss = glrget('RMISS')
gllset('LMISS', true)

#-- data ---
for j in 0..NY-1
  for i in 0..NX-1
    alon = (XMIN + (XMAX-XMIN)*i/(NX-1)) * DRAD
    alat = (YMIN + (YMAX-YMIN)*j/(NY-1)) * DRAD
    slat = sin(alat)
    p[i,j] = 3*sqrt(1-slat**2)*slat*cos(alon) - 0.5*(3*slat**2-1)
    if ( i == 5 && j == 5 )
      p[i,j] = rmiss
    end
    if ( ( 7 <= i && i <= 23) && j == 29 )
      p[i,j] = rmiss
    end
    if( (21 <= i && i <= 29) && (11 <= j && j <= 19))
      p[i,j] = rmiss
    end
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uetone(p)
usdaxs
udcntr(p)

grcls

