#
# u2d4.rb
#   $Id: u2d4.rb,v 1.2 2000/11/18 19:03:45 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math


NX = 37
NY = 37
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = 90
DRAD = PI / 180
KXMN = 9
KXMX = 33
KYMN = 7
KYMX = 31

p = NArray.sfloat(NX, NY)
alon = NArray.sfloat(NX)
alat = NArray.sfloat(NY)

#-- data ---
for i in 0..NX-1
  alon[i] = XMIN + (XMAX-XMIN)*i/(NX-1).to_f
end
for j in 0..NY-1
  alat[j] = YMIN + (YMAX-YMIN)*j/(NY-1).to_f
end

for j in 0..NY-1
  slat = sin(alat[j]*DRAD)
  for i in 0..NX-1
    p[i,j] = 3*sqrt(1-slat**2)*slat*cos(alon[i]*DRAD) - 0.5*(3*slat**2-1)
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

grswnd(alon[KXMN-1], alon[KXMX-1], alat[KYMN-1], alat[KYMX-1])
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

usdaxs
udcntr(p[(KXMN-1)..(KXMX-1), (KYMN-1)..(KYMX-1)])

grcls

